package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.platform.bean.SysFile;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IFileManageService {

    /**
     * 上传文件
     * @param file 文件
     * @return 文件信息
     */
    @ApiOperation(value = "上传文件", notes = "上传文件")
    SysFile uploadFile(MultipartFile file);

    /**
     * 获取文件
     * @param resp
     * @param fileUrl 文件url
     * @return 文件流
     */
    void getFileByUrl(HttpServletResponse resp, String fileUrl);
}
