package cn.estsh.i3plus.ext.mes.api.busi.bu;

import cn.estsh.i3plus.ext.mes.pojo.model.bu.SxStandardWorkReportModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description: 机种别工数报表
 **/
public interface ISxStandardWorkReportFormService {

    /**
     * 仅班次信息
     * @param organizeCode
     * @return
     */
    @ApiOperation(value = "仅班次信息", notes = "仅班次信息")
    Map<String, String> querySingleShiftList(String organizeCode);

    /**
     * 机种别工数报表
     *
     * @param model 查询条件
     * @return 机种别工数报表
     */
    @ApiOperation(value = "机种别工数报表", notes = "机种别工数报表")
    List<SxStandardWorkReportModel> queryStandardWorkReportForm(SxStandardWorkReportModel model);
}
