package cn.estsh.i3plus.ext.mes.api.busi.jx;

import cn.estsh.i3plus.ext.mes.pojo.bean.SxWorkCellTaktCollectRecord;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

public interface ISxWorkCellTaktCollectRecordService {

    /**
     * 条件分页查询松下工位节拍采集记录
     * @param workCellTaktCollectRecord 松下工位节拍采集记录
     * @return 包装条码明细信息
     */
    @ApiOperation(value = "根据产品条码查询包装条码明细信息", notes = "根据产品条码查询包装条码明细信息")
    ListPager<SxWorkCellTaktCollectRecord> queryWorkCellTaktCollectRecrodLByPager(SxWorkCellTaktCollectRecord workCellTaktCollectRecord, Pager pager);

    /**
     * 条件分页查询松下工位节拍采集记录
     * @param ids id集合
     * @param status 状态
     * @param userName 用户名
     * @return 包装条码明细信息
     */
    @ApiOperation(value = "根据产品条码查询包装条码明细信息", notes = "根据产品条码查询包装条码明细信息")
    int updateWorkCellTaktCollectRecordValid(String[] ids, int status, String userName);

}
