package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesBomTakeEffectRecord;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;

/**
 * 文件描述 BOM生效记录
 *
 * @author xiangming.liao
 * @date 2021年05月06日 10:08
 */
public interface IBomTakeEffectRecordService {

    /**
     * @Description: 按条件分页查询BOM生效记录
     * @Param [bomTakeEffectRecord, pager]
     * @return cn.estsh.i3plus.pojo.base.bean.ListPager<cn.estsh.i3plus.ext.mes.pojo.bean.MesBomTakeEffectRecord>
     * @Date 2021/5/6 10:10
     **/
    ListPager<MesBomTakeEffectRecord> queryByPager(MesBomTakeEffectRecord bomTakeEffectRecord, Pager pager);
}
