package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.model.ExcelImportResultExtModel;
import io.swagger.annotations.ApiOperation;
import org.apache.poi.ss.usermodel.Workbook;

/**
 * @Description : 导入
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2019-08-26
 * @Modify:
 **/
public interface IExcelImportExtService {

    /**
     * mes导入
     *
     * @param workbook     工作簿
     * @param organizeCode 组织代码
     * @param userName     操作人
     * @return 导入结果model
     */
    @ApiOperation(value = "mes导入", notes = "mes导入")
    ExcelImportResultExtModel insertDataByExcel(Workbook workbook, String organizeCode, String userName);

}
