package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesFourMChange;
import cn.estsh.i3plus.ext.mes.pojo.model.FourMChangeModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/2 13:41
 **/
public interface IFourMChangeService {

    /**
     * 新增
     *
     * @param fourMChange
     * @return
     */
    MesFourMChange insert(MesFourMChange fourMChange);

    /**
     * 修改
     *
     * @param fourMChange
     * @return
     */
    MesFourMChange update(MesFourMChange fourMChange);

    /**
     * 查询
     *
     * @param fourMChange
     * @param pager
     * @return
     */
    ListPager<FourMChangeModel> queryByPager(MesFourMChange fourMChange, Pager pager);

    /**
     * 根据
     *
     * @param id
     * @param status
     * @return
     */
    int updateIsValidById(long id, Integer status);


}
