package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesModuleFileImportLot;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IModuleFileImportLotService {

    /**
     * 按条件分页查询模块文件导入批次信息
     * @param moduleFileImportLot 查询条件
     * @param pager 分页条件
     * @return 模块文件导入批次信息
     */
    ListPager<MesModuleFileImportLot> queryModuleFileImportLotByPager(MesModuleFileImportLot moduleFileImportLot, Pager pager);
}
