package cn.estsh.i3plus.ext.mes.api.base.ep;

import cn.estsh.i3plus.pojo.mes.bean.MesObjectCfg;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IEpObjectCfgExtService {

    /**
     * 新增对象结构信息
     * @param objectCfg 对象结构信息
     * @return 班次作业项目数据
     */
    @ApiOperation(value = "新增对象结构信息", notes = "新增对象结构信息")
    MesObjectCfg insertObjectCfg(MesObjectCfg objectCfg);

    /**
     * 更新对象结构信息
     * @param objectCfg 对象结构信息
     * @return 班次作业项目数据
     */
    @ApiOperation(value = "更新对象结构信息", notes = "更新对象结构信息")
    MesObjectCfg updateObjectCfg(MesObjectCfg objectCfg);

}
