package cn.estsh.i3plus.ext.mes.api.busi;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesWorkOrderExt;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/1/29 13:24
 **/
public interface IWorkOrderStartService {
    /**
     * 工单启动后方法执行
     *
     * @param mesWorkOrderExt 工单
     * @return {@link ResultBean}
     */
//    @Transactional(propagation = Propagation.REQUIRES_NEW,noRollbackFor = {ImppBusiException.class,Exception.class})
    ResultBean execute(MesWorkOrderExt mesWorkOrderExt);
}
