package cn.estsh.i3plus.ext.mes.api.busi.bu;

import cn.estsh.i3plus.ext.mes.pojo.model.bu.MesPatchPartConfirmModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.impp.framework.boot.util.ResultBean;

import java.util.List;

public interface IBuPatchPartConfirmService {
    /**
     * 查询异常下线数据
     * @param orderNo
     * @param userName
     * @param organizeCode
     * @return
     */
    ListPager getExOffline(String orderNo, String userName, String organizeCode, Pager pager);

    /**
     * 查询原始子物料
     * @return
     */
    List getBeforeOartBom(MesPatchPartConfirmModel patchPartConfirmModel);

    /**
     * 查询新子物料
     * @param userName
     * @param organizeCode
     * @return
     */
    List getAfterOartBom(String partNo, String userName, String organizeCode, String itemPartNo, String itemPartName ,Integer isBindKey);

    /**
     * 替换原有子物料号
     * @return
     */
    void insertUpdateReplacePartBom(MesPatchPartConfirmModel patchPartConfirmModel);
}
