package cn.estsh.i3plus.ext.mes.apiservice.dao.jx;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesProduceSnExt;
import cn.estsh.i3plus.ext.mes.pojo.model.jx.OqcLastCheckModel;
import cn.estsh.i3plus.pojo.base.common.Pager;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2019/11/21 11:28 上午
 * @Description:
 **/
public interface IJxProduceSnDao {

    /**
     * 查询产品条码数量
     * @param model 查询信息
     * @return 总检验结果数量
     */
    int queryProduceSnByPagerCount(OqcLastCheckModel model);

    /**
     * 查询产品条码信息集合
     * @param model 查询信息
     * @param pager 分页条件
     * @return SOP信息集合
     */
    List<MesProduceSnExt> queryProduceSnByPager(OqcLastCheckModel model, Pager pager);
}
