package cn.estsh.i3plus.ext.mes.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 文件描述
 *
 * @author xiangming.liao
 * @date 2021年06月29日 17:52
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_NUMBER_OF_SAFE_OPERATION_DAYS")
@Api("MES_安全运行天数")
public class MesNumberOfSafeOperationDays extends BaseBean implements Serializable {
    private static final long serialVersionUID = -5767394781323696380L;

    @Column(name = "INIT_START_DATE")
    @ApiParam(value = "初始开始日期")
    private String initStartDate;

    @Column(name = "INIT_END_DATE")
    @ApiParam(value = "初始结束日期")
    private String initEndDate;

    @Column(name = "INIT_DAYS")
    @ApiParam(value = "初始天数")
    private Integer initDays;
}
