package cn.estsh.i3plus.ext.mes.pojo.model;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesAccidentDate;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import javax.persistence.Transient;
import java.io.Serializable;
import java.util.List;

/**
 * 文件描述
 *
 * @author xiangming.liao
 * @date 2021年08月26日 21:19
 */
@Data
@ApiModel("事故日期Model")
public class MesAccidentDateModel implements Serializable {

    private static final long serialVersionUID = -36619585347105824L;

    @ApiParam(value = "事故集合")
    List<MesAccidentDate> mesAccidentDateList;

    @ApiParam(value = "事故天数")
    private Integer accidentDays;

    @ApiParam(value = "事故统计年月起始范围")
    private String statisticsDateScope;
}
