package cn.estsh.i3plus.ext.mes.pojo.model.bu;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;

import java.io.Serializable;

/**
 * @PROJECT_NAME: i3plus-mes-panasonic-bu
 * @DESCRIPTION:
 * @USER: xinwang.yi
 * @DATE: 2022-07-06 14:31
 */
@Data
@ApiModel("工程不良率MODEL")
public class BuProjectBadRate implements Serializable {
    private static final long serialVersionUID = -2968868377763574884L;

    @ApiParam("生产日期")
    private String workDate;

    @ApiParam("生产台数")
    private String produceQty;

    @ApiParam("物料编码")
    private String partNo;

    @ApiParam("不良类型")
    private String badnessCode;

    @ApiParam("不良率")
    private String badnessRate;
}
