package cn.estsh.i3plus.ext.mes.pojo.model.bu3;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @DESCRIPTION:
 * @USER: wangjie
 * @DATE: 2022-11-01 15:54
 */
@Data
@ApiModel("日常点检报表设备点检数据MODEL")
public class SxDailyCheckEquCheckDataModel implements Serializable {

    private static final long serialVersionUID = -4543194128801524102L;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam(value ="单据状态")
    private Integer orderStatus;

    @ApiParam("设备编号")
    private String equNo;

    @ApiParam("设备名称")
    private String equName;

    @ApiParam("作业时间(年月日时分秒)")
    private String workTimeStart;

    @ApiParam("作业时间(年月日时分秒)")
    private String workTimeEnd;

    @ApiParam("班次代码")
    private String shiftCode;

    @ApiParam("工作中心代码")
    private String workCenterCode;

    @ApiParam("项目内容")
    private String projectContent;

    @ApiParam("点检方法")
    private String checkMethod;

    @ApiParam("点检周期")
    private String checkType;

    @ApiParam("点检人员")
    private String spotCheckUser;

    @ApiParam("点检时间")
    private String spotCheckTime;

    @ApiParam("班组确认人")
    private String teamConfirmUser;

    @ApiParam("班组确认时间")
    private String teamConfirmTime;

    @ApiParam("点检结果")
    private Integer checkResult;

    @ApiParam("结果值")
    private String resultValue;

    @ApiParam(value = "备注")
    public String remark;

    @ApiParam("实际结果")
    private String result;

    @ApiParam("日期标志")
    private String dateFlag;

    @ApiParam("时间段标志")
    private String timeFlag;

    public SxDailyCheckEquCheckDataModel() {}

    public SxDailyCheckEquCheckDataModel(String equNo, String equName, String projectContent, String checkMethod, String checkType, String spotCheckUser, String spotCheckTime,
                                         String teamConfirmUser, String teamConfirmTime, Integer checkResult, String resultValue, String remark) {
        this.equNo = equNo;
        this.equName = equName;
        this.projectContent = projectContent;
        this.checkMethod = checkMethod;
        this.checkType = checkType;
        this.spotCheckUser = spotCheckUser;
        this.spotCheckTime = spotCheckTime;
        this.teamConfirmUser = teamConfirmUser;
        this.teamConfirmTime = teamConfirmTime;
        this.checkResult = checkResult;
        this.resultValue = resultValue;
        this.remark = remark;
    }

    public SxDailyCheckEquCheckDataModel orderStatus(Integer orderStatus) {
        this.orderStatus = orderStatus;
        return this;
    }
}
